#
# Conditional build:
%bcond_without	libunwind	# strack tracing using libunwind
%bcond_without	libiberty	# symbol demangling in stack backtraces
#
%ifnarch %{ix86} %{x8664} x32 %{arm} hppa ia64 mips ppc ppc64 sh
%undefine	with_libunwind
%endif
Summary:	prints system call strace of a running process
Summary(de.UTF-8):	druckt ein Protokoll der Systemaufrufe eines laufenden Prozesses
Summary(es.UTF-8):	Enseña las llamadas de sistema de un proceso en ejecución
Summary(fr.UTF-8):	affiche l'appel système strace d'un processus en exécution
Summary(pl.UTF-8):	strace wyświetla funkcje systemowe wywoływane przez uruchomiony proces
Summary(pt_BR.UTF-8):	Mostra as chamadas de sistema de um processo rodando
Summary(ru.UTF-8):	Отслеживает и показывает системные вызовы, связанные с запущенным процессом
Summary(tr.UTF-8):	Çalışan bir sürecin yaptığı sistem çağrılarını listeler
Summary(uk.UTF-8):	Відслідковує та показує системні виклики, пов'язані із запущеним процесом
Name:		strace
Version:	5.5
Release:	1
License:	LGPL v2.1+
Group:		Development/Debuggers
Source0:	https://github.com/strace/strace/releases/download/v%{version}/%{name}-%{version}.tar.xz
# Source0-md5:	dbce2e84632b39a4ed86b9fc60447af9
Source1:	%{name}.1.pl
URL:		https://strace.io/
# acl and libaio for headers only
BuildRequires:	acl-devel
%{?with_libiberty:BuildRequires:	binutils-devel >= 4:2.30-1}
BuildRequires:	libaio-devel
%{?with_libunwind:BuildRequires:	libunwind-devel}
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Strace prints a record of each system call another program makes,
including all of the arguments passed to it and the system call's
return value.

%description -l de.UTF-8
Strace druckt ein Protokoll aller von einem anderen Programm
ausgegebenen Systemaufrufe, einschließlich aller weitergeleiteten
Argumente und dem Ausgabewert des Systemaufrufs.

%description -l es.UTF-8
Strace imprime una "grabación" de cada llamada de sistema que el
programa hace, incluyendo todos los argumentos pasados para él, si la
vuelta de cada llamada de sistema es verdadera, o si hay creado error.

%description -l fr.UTF-8
strace affiche l'enregistrement de chaque appel système que fait un
programme ainsi que tous les arguments qui lui ont été passés et la
valeur de retour de l'appel.

%description -l pl.UTF-8
Strace wyświetla informacje o każdym wywołaniu funkcji systemowych
przez uruchamiany program, w tym również wszystkie argumenty wywołania
i zwróconą wartość.

%description -l pt_BR.UTF-8
Strace imprime uma "gravação" de cada chamada de sistema que o
programa faz, incluindo todos os argumentos passados para ele e se o
retorno de cada chamada de sistema é verdadeiro ou gerou erro.

%description -l ru.UTF-8
Программа strace перехватывает и регистрирует системные вызовы,
произведенные и полученные исполняющимся процессом. Strace может
вывести список всех системных вызовов, их аргументов и возвращаемые
ими значения. Strace полезна для диагностики проблем и отладки.

%description -l tr.UTF-8
strace bir programın çalıştığı sürece yaptığı bütün sistem
çağrılarını, gönderdiği parametreler ve geri dönüş değerleriyle
birlikte döker.

%description -l uk.UTF-8
Програма strace перехоплює та регіструє системні визови, зроблені та
отримані процесом, який виконується. Strace може вивести список усіх
системних визовів, їх аргументів та значень, які вони повернули.
Strace корисний для діагностики проблем та відладки.

%package graph
Summary:	strace graph
Summary(pl.UTF-8):	Graf strace
Group:		Development/Debuggers
# NOTE: doesn't require directly strace binary.

%description graph
strace-graph script processes strace -f output. It displays a graph of
invoked subprocesses, and is useful for finding out what complex
commands do.

The script can also handle the output with strace -t, -tt, or -ttt. It
will add elapsed time for each process in that case.

%description graph -l pl.UTF-8
Skrypt strace-graph przetwarza wynik strace -f i wyświetla graf
wywoływanych podprocesów. Jest przydatny do sprawdzania co robią
złożone polecenia.

Skrypt jest w stanie obsłużyć także wyjście ze strace -t, -tt i -ttt.
Doda wtedy upływający czas dla każdego procesu.

%prep
%setup -q

%build
%if %{with libunwind}
# workaround for:
# /usr/bin/ld: copy reloc against protected `_UPT_accessors' is invalid
# /usr/bin/ld: failed to set dynamic section sizes: Bad value
# (should be fixed in gcc >(=?) 5.1)
CFLAGS="%{rpmcflags} -fPIE"
%endif
%configure \
	%{!?with_libiberty:--without-libiberty} \
	%{!?with_libunwind:--without-libunwind}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -D %{SOURCE1} $RPM_BUILD_ROOT%{_mandir}/pl/man1/strace.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING CREDITS ChangeLog NEWS README-linux-ptrace
%attr(755,root,root) %{_bindir}/strace
%attr(755,root,root) %{_bindir}/strace-log-merge
%{_mandir}/man1/strace.1*
%{_mandir}/man1/strace-log-merge.1*
%lang(pl) %{_mandir}/pl/man1/strace.1*

%files graph
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/strace-graph
%changelog
* Mon Apr 06 2020 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/strace.git;a=log;h=master

* Wed Feb 19 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> e5a900a
- up to 5.5

* Mon Dec 09 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 55e5dbf
- up to 5.4

* Sat Sep 28 2019 Adam Gołębiowski <adamg@pld-linux.org> be66a68
- updated to 5.3

* Tue Jul 16 2019 Adam Gołębiowski <adamg@pld-linux.org> dc76a74
- updated to 5.2

* Wed May 29 2019 Adam Gołębiowski <adamg@pld-linux.org> 561a34b
- updated to 5.1

* Tue Mar 19 2019 Adam Gołębiowski <adamg@pld-linux.org> 5b1516f
- updated to 5.0

* Sat Dec 29 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 6867b52
- up to 4.26

* Tue Oct 30 2018 Adam Gołębiowski <adamg@pld-linux.org> e6c217c
- updated 4.25

* Mon Oct 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> b4f9482
- up to 4.24

* Tue Jun 19 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> d772fea
- up to 4.23

* Sat Apr 07 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 4878aec
- up to 4.22

* Mon Feb 26 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 0e691b8
- release 4 (by relup.sh)

* Mon Feb 26 2018 Jakub Bogusz <qboosh@pld-linux.org> 74c93f8
- for demangler, require binutils-devel with all libiberty headers; release 3

* Sun Feb 25 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 14ebb9c
- release 2 (by relup.sh)

* Sat Feb 24 2018 Jakub Bogusz <qboosh@pld-linux.org> 419f723
- enable libunwind on x32, handle libiberty

* Sat Feb 24 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 03680bd
- new urls

* Sat Feb 24 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> fed9ce2
- up to 4.21

* Wed Nov 15 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 2487f8b
- up to 4.20

* Tue Oct 03 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 70d2a35
- up to 4.19

* Wed Aug 09 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 27909ca
- up to 4.18

